/* E-Launch.c
 *
 * Copyright (C) 1999 Ejvend Nielsen (a.k.a.  Cytrix)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 *
 * Credits: Rasterman and Mandrake - For such a wonderful and enlightening WM.
 *          Montgomery Farrar Tidwll - He was the first I found out after working on this
 *                                     epplet to create a launcher called 'E-Xecute'. I 
 *                                     borrowed his "esc" key code to add to my epplet.
 *			Kenneth Hinson (TaoX) - For pointing out some suggestion on memory and speed 
 *									code modifications.  As well as some second opinions...Thanks TaoX. :-) 
 * 
 * To Create the icons for E-Launch open the image in gimp and scale the image to 12x12.
 * Then copy the icon to your epplet_data/E-Launch directory or where ever you keep the
 * epplets icons.
 *
 *
 * I know my code is messy, eventually I will clean it up.
*/
/********************************************* INCLUDES*****************************************************/
#include "E-Launch.h"

/********************************************* MISC *********************************************************/
static void 
mouse_cb(void *data, Window w, int x, int y, int b)
{
	page=b;
	page_epplet();
}

static void key_cb(void *data, Window w, char *key)
{
   switch(*key)
   {
      case 69:
	    close_cb(NULL);
	  	break;
	  case 70:
		config_cb(NULL);
		break;
	  case 49:
	  case 50:
	  case 51:
		page=((*key)-48);
		page_epplet();
   }
}

static void
close_cb(void *data)
{
   Epplet_remember();
   Epplet_cleanup();
   exit(0);
}

static void
in_cb(void *data, Window w)
{
   if(cfg_show_buttons)
   {
	   Epplet_gadget_show(b_close);
	   Epplet_gadget_show(b_config);
   }
   return;
}

static void
out_cb(void *data, Window w)
{
   if(cfg_show_buttons) 
   {
	   Epplet_gadget_hide(b_close);
	   Epplet_gadget_hide(b_config);
   }
   return;
}

static void 
execute_cb(void *data)
{
   if( data != NULL ) Epplet_spawn_command(data);
}

static void 
load_icons(void)
{
   int t, x, y;
   int t_cnt=28;
   int x_cnt = 4;
   int y_cnt = 4;
   char s[256];

   for(t=0; t<3; t++)
   {
       b_label[t] = Epplet_create_label(3, 3, label[t], 1);
   }

   t = 1;
	
   while(t<t_cnt)	   
   {
	   for(y = 1; y < y_cnt; y++)
	   {
		  for(x = 1; x < x_cnt; x++)	   
		  {
		      sprintf(s, "%s\n", icon[t-1]);
			  b_icons[(b_cnt)++] = Epplet_create_button(NULL, icon[t-1], button_posX[x-1], button_posY[y-1], 13,                                                                                                                                 13, NULL, 0, NULL, execute_cb, prog[t-1]);
			  t++;
     	 }  
	  }
   }

   display_label();   
   display_icons();
}

static void 
page_epplet(void)
{
   hide_label();
   hide_icons();
   display_label();
   display_icons();
}

static void
hide_icons(void)
{
   int b;

   for(b=0; b<b_cnt; b++) Epplet_gadget_hide(b_icons[b]);
}

static void 
display_icons(void)
{
   int b, c;
     
   if(page==1)  {b=0; c=9; }
   else if(page==2) {b=9; c=18;}
   else if(page==3) {b=18; c=b_cnt;}
   
   for(b; b<c; b++)
   {
	   if(strcmp(icon[b], "none")) Epplet_gadget_show(b_icons[b]);
   }
}

static void
recreate_icons(void)
{
   int t, x, y;
   int t_cnt=28;
   int x_cnt = 4;
   int y_cnt = 4;
   char s[256];

   for(t=0; t<27; t++)
   {
	   Epplet_gadget_destroy(b_icons[t]);
   }

   t = 1;
   b_cnt = 0;
   while(t<t_cnt)	   
   {
	   for(y = 1; y < y_cnt; y++)
	   {
		  for(x = 1; x < x_cnt; x++)	   
		  {
		      sprintf(s, "%s\n", icon[t-1]);
			  b_icons[(b_cnt)++] = Epplet_create_button(NULL, icon[t-1], button_posX[x-1], button_posY[y-1], 13,                                                                                                                                 13, NULL, 0, NULL, execute_cb, prog[t-1]);
			  t++;
       	  }  
       }
   }

   display_icons();
}

static void
hide_label(void)
{
   int b;

   for(b=0; b<3; b++) Epplet_gadget_hide(b_label[b]);
}

static void
display_label(void)
{
   if(page==1) 
   {
	   if(strcmp(label[0], "none")) Epplet_gadget_show(b_label[0]);
   }
   else if(page==2) 
   {
	   if(strcmp(label[1], "none")) Epplet_gadget_show(b_label[1]);
   }
   else if(page==3) 
   {
	   if(strcmp(label[2], "none")) Epplet_gadget_show(b_label[2]);
   }
}

static void
recreate_label(void)
{
   int t;

   for(t=0; t<3; t++)
   {
	   Epplet_gadget_destroy(b_label[t]);
   }

   for(t=0; t<3; t++)
   {
       b_label[t] = Epplet_create_label(3, 3, label[t], 1);
   }
   
   display_label();
}

/********************************************* CONFIG *******************************************************/

static void
process_config(void) 
{
   int t;	
   int t_cnt=28;
   char *s;
   char i[7];


   cfg_show_buttons = atoi(Epplet_query_config_def("Show_buttons", SHOW_BUTTONS));

   label[0] = Epplet_query_config_def("page_1", PAGE_1);
   label[1] = Epplet_query_config_def("page_2", PAGE_2);
   label[2] = Epplet_query_config_def("page_3", PAGE_3);
   
   for(t = 1; t < t_cnt; t++)
   {
      sprintf(i, "icon_%i", t);
      s = Epplet_query_config_def(i, icon_def[t-1]);
      icon[t-1] = s;
      sprintf(i, "prog_%i", t);
      s = Epplet_query_config_def(i, prog_def[t-1]);
      prog[t-1] = s;
   }
}

static void
config_cb(void *data)
{
   char *s;
   char i[7];
		
   if(config_win) return;
   
   config_win = Epplet_create_window_config(230, 170, "E-Launch Configuration",                                                                                                                                                              ok_cb, NULL, apply_cb, NULL, cancel_cb, NULL);

   Epplet_gadget_show(Epplet_create_label(4, 4, "Page 1 label:", 2));
   Epplet_gadget_show(Page_1_Label = Epplet_create_textbox(NULL, label[0], 4, 18, 64, 20, 2, NULL, NULL));

   Epplet_gadget_show(Epplet_create_label(80, 4, "Page 2 label:", 2));
   Epplet_gadget_show(Page_2_Label = Epplet_create_textbox(NULL, label[1], 80, 18, 64, 20, 2, NULL, NULL));

   Epplet_gadget_show(Epplet_create_label(160, 4, "Page 3 label:", 2));
   Epplet_gadget_show(Page_3_Label = Epplet_create_textbox(NULL, label[2], 160, 18, 64, 20, 2, NULL, NULL));

   Epplet_gadget_show(Epplet_create_label(10, 45, "Configure\nPage 1:", 2));
   Epplet_gadget_show(Epplet_create_button(NULL, pic, 10, 70, 50, 50, NULL, 0, NULL, config_page_cb, "1"));
   Epplet_gadget_show(Epplet_create_label(86, 45, "Configure\nPage 2:", 2));
   Epplet_gadget_show(Epplet_create_button(NULL, pic, 86, 70, 50, 50, NULL, 0, NULL, config_page_cb, "2"));
   Epplet_gadget_show(Epplet_create_label(166, 45, "Configure\nPage 3:", 2));
   Epplet_gadget_show(Epplet_create_button(NULL, pic, 166, 70, 50, 50, NULL, 0, NULL, config_page_cb, "3"));

   Epplet_gadget_show(Epplet_create_togglebutton(NULL, NULL, 4, 130, 12, 12, &cfg_show_buttons, NULL, NULL));
   Epplet_gadget_show(Epplet_create_label(20, 130, "Show epplet close/config buttons.", 2));

   Epplet_window_show(config_win);
   Epplet_window_pop_context();

   return;
}

static void
config_page_cb(void *data)
{
   int a, b, c;
   char buff[10];

   if(config_page_win) return;

   config_page_win = Epplet_create_window(525, 400, "E-Launch Page Configuration", 2);

   config_page = atoi(data);
   if(config_page==1)  {b=0; c=9; }
   else if(config_page==2) {b=9; c=18;}
   else if(config_page==3) {b=18; c=b_cnt;}

   a = 0;
   for(b; b<c; b++)
   {
        sprintf(buff, "Icon_%d", b+1);
		Epplet_gadget_show(Epplet_create_label(4, 4+(40*a), buff, 2));
        Epplet_gadget_show(Page_Icon_Text[b] = Epplet_create_textbox(NULL, icon[b], 4, 18+(40*a), 256, 20, 2, NULL, NULL));

        sprintf(buff, "Program_%d", b+1);
		Epplet_gadget_show(Epplet_create_label(264, 4+(40*a), buff, 2));
		Epplet_gadget_show(Page_Prog_Text[b] = Epplet_create_textbox(NULL, prog[b], 264, 18+(40*a), 256, 20, 2, NULL, NULL));

        a++;
   }


   Epplet_gadget_show(Epplet_create_button("Ok", NULL, 413, 380, 48, 18, NULL, 0, NULL, ok_page_cb, NULL));
   Epplet_gadget_show(Epplet_create_button("Cancel", NULL, 471, 380, 48, 18, NULL, 0, NULL, cancel_page_cb, NULL));


   Epplet_window_show(config_page_win);
   Epplet_window_pop_context();

   return;
}

static void
apply_config(void)
{
   char buff[1024];
    
   strcpy(buff, Epplet_textbox_contents(Page_1_Label));
   Epplet_modify_config("page_1", buff);
   label[0] = Epplet_query_config("page_1");   	

   strcpy(buff, Epplet_textbox_contents(Page_2_Label));
   Epplet_modify_config("page_2", buff);
   label[1] = Epplet_query_config("page_2");   	

   strcpy(buff, Epplet_textbox_contents(Page_3_Label));
   Epplet_modify_config("page_3", buff);
   label[2] = Epplet_query_config("page_3"); 

   recreate_label();

   sprintf(buff, "%d", cfg_show_buttons);
   Epplet_modify_config("Show_buttons", buff);

   if(!cfg_show_buttons) 
   {
	   Epplet_gadget_hide(b_close);
	   Epplet_gadget_hide(b_config);
   }
}

static void
ok_cb(void *data)
{
	apply_config();
	Epplet_save_config();
	Epplet_window_destroy(config_win);
	
	config_win = None;
  	
	return;
}

static void
apply_cb(void *data)
{
	apply_config();
	return;
}

static void
cancel_cb(void *data)
{
	Epplet_window_destroy(config_win);

	config_win = None;

	return;
}

static void
apply_page_config(void)
{
   int b, c;
   char s[256];
   char buff[1024];
    
   if(config_page==1)  {b=0; c=9; }
   else if(config_page==2) {b=9; c=18;}
   else if(config_page==3) {b=18; c=b_cnt;}
   
   for(b; b<c; b++)
   {
        strcpy(buff, Epplet_textbox_contents(Page_Icon_Text[b]));
        sprintf(s, "icon_%d", b+1);
        Epplet_modify_config(s, buff);
		icon[b] = Epplet_query_config(s);

		strcpy(buff, Epplet_textbox_contents(Page_Prog_Text[b]));
        sprintf(s, "prog_%d", b+1);
		Epplet_modify_config(s, buff);
		prog[b] = Epplet_query_config(s);
    }

    recreate_icons();    
}

static void
ok_page_cb(void *data)
{
    apply_page_config();
    Epplet_save_config();
	Epplet_window_destroy(config_page_win);
	
	config_page_win = None;
  	
	return;
}

static void
cancel_page_cb(void *data)
{
	Epplet_window_destroy(config_page_win);

	config_page_win = None;

	return;
}
/********************************************* MAIN *********************************************************/

int
main(int argc, char **argv)
{
   int prio;

   prio = getpriority(PRIO_PROCESS, getpid());
   setpriority(PRIO_PROCESS, getpid(), prio + 10);
   atexit(Epplet_cleanup);
	
   Epplet_Init("E-Launch", "0.10", "Enlightenment Quick Launch Epplet", 3, 3, argc, argv, 0);
   b_close = Epplet_create_std_button("CLOSE", 34, 2, close_cb, NULL);
   b_config = Epplet_create_std_button("CONFIGURE", 2, 2, config_cb, NULL);
   b_label[0] = Epplet_create_label(3, 3, "E-Launch", 1);		    
   
   Epplet_register_focus_in_handler(in_cb, NULL);
   Epplet_register_focus_out_handler(out_cb, NULL);
   Epplet_register_key_release_handler(key_cb, NULL);
   Epplet_register_button_press_handler(mouse_cb, NULL);

   Epplet_load_config();
   process_config();
   
   load_icons();
   
   Epplet_show();
   Epplet_Loop();
   return 0;
}
